<?php

namespace App\Console\Test;

use App\Cache\UserCache;
use App\Facade\Site;
use App\Libs\TikTok\Kernel\Support\Str;
use App\Services\DeepSeek\DeepSeekService;
use GuzzleHttp\Client;
use Illuminate\Console\Command;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Redis;
use Illuminate\Support\Facades\Storage;
use Vinkla\Hashids\Facades\Hashids;

use function PHPSTORM_META\map;

/**
 * 测试
 */
class TestCommand extends Command
{
    /**
     * @var string
     */
    protected $signature = 'test {--token=} {--uid=} {--eid=}';

    /**
     * The console command description.
     *  php artisan Payment:BasePayment --bid='1'
     *
     * @var string
     */
    protected $description = '测试';
    protected $deepseekService;


    public function __construct(DeepSeekService $deepseekService
    )
    {
        parent::__construct();
        $this->deepseekService = $deepseekService;
    }


    /**
     * handle
     */
    public function handle()
    {
        ini_set('max_execution_time', 0);
        \Log::info('~~~~~~~~~~~~~~~~~~~~~~~~开始~~~~~~~~~~~~~~~~~~~~~~~~');
        // $a = DB::table('mp_emotion_list')->pluck('emotion_name')->toArray();
        // dd(implode('、', $a));
        // $emotion_str = '​开心（happy），悲伤（sad），生气（angry），惊讶（surprised），恐惧（fear），厌恶（hate），激动（excited），冷漠（coldness），中性（neutral），沮丧（depressed），撒娇（lovey-dovey），害羞（shy），安慰鼓励（comfort），咆哮/焦急（tension），温柔（tender），讲故事 / 自然讲述（storytelling），情感电台（radio），磁性（magnetic），广告营销（advertising），气泡音（vocal - fry），低语 (ASMR)，新闻播报（news），娱乐八卦（entertainment），方言（dialect）';
        // $emotion_arr = explode('，', $emotion_str);
        // $insert_data = [];
        // foreach ($emotion_arr as $emotion) {
        //     preg_match('/(.*)?（(.*?)）/', $emotion, $match);
        //     if (count($match) == 3) {
        //         $insert_data[] = [
        //             'emotion_code'  => $match[2],
        //             'emotion_name'  => $match[1],
        //             'is_enabled'    => 1,
        //             'created_at'    => date('Y-m-d H:i:s'),
        //             'updated_at'    => date('Y-m-d H:i:s'),
        //         ];
        //     }
        // }
        // DB::table('mp_emotion_list')->insert($insert_data);
        // exit();

        $bid = 10917;
        $version_id = 1649;
        $cid = 2669608;

        // $text = '"旁白：刀尖刺穿手掌的瞬间，疼痛自掌心钻入骨髓。{自然讲述}  \n旁白：心脏像是被万箭穿过一般，我痛得几近晕厥。{自然讲述}  \n旁白：可赵晏池显然不愿让我那么痛快地昏过去。{自然讲述}  \n旁白：他命人用一盆盆冰凉刺骨的冷水强行让我保持清醒。{自然讲述}  \n旁白：血迹混杂着水迹在身下漫开，任谁看了都触目惊心。{自然讲述}  \n旁白：意识涣散间，我仿佛在脑海中看到走马灯。{自然讲述}  \n旁白：结婚七年，圈子里无人不知我是赵晏池宠在心尖上的人。{自然讲述}  \n旁白：他会在拍卖会上一掷千金买下我随口说喜欢的东西。{自然讲述}  \n旁白：他会在我生病的时候亲自衣不解带地照顾我。{自然讲述}  \n旁白：从不落泪的男人，看到我身体难受吃不下饭时却心疼得湿了眼眶。{自然讲述}  \n旁白：他会在求婚那天，包下国内外所有大荧幕，高调地向全世界宣布爱我。{自然讲述}  \n旁白：那一夜，满城的天都被他准备的烟花照亮。{自然讲述}  \n旁白：绚烂的烟火下，他深情款款地看着我的眼睛。{自然讲述}  \n赵晏池(男)：我就是要让所有人都知道，你是我赵晏池的夫人，是我的心头肉。{温柔}  \n赵晏池(男)：有我保护你，谁都别想动你一根手指头。{温柔}  \n旁白：可偏偏如今，伤我最深的，就是给过我这些承诺的人。{自然讲述}  \n旁白：压制着我的保镖终于将我松开。{自然讲述}  \n旁白：我想摸摸肚子里的孩子，却根本抬不起手。{自然讲述}  \n旁白：我的手已经被彻底废掉，绵软得使不上一点力气。{自然讲述}  \n赵晏池(男)：把她给我扔出去，别在这边脏了我们的眼睛。{冷漠}  \n旁白：保镖正要照做，却又被旁边的女人制止。{自然讲述}  \n汪思月(女)：等等。{温柔}  \n旁白：她声音轻柔，却像是恶鬼的轻语：{自然讲述}  \n汪思月(女)：晏池，我看他们也挺辛苦的。{温柔}  \n汪思月(女)：这个女的身材看着倒是不错，不如就赏给他们玩玩吧。{温柔}  \n旁白：下一秒，赵晏池宠溺的声音响起。{自然讲述}  \n赵晏池(男)：思月，还是你小主意最多。{温柔}  \n旁白：听到这个有些耳熟的名字，我努力抬起肿起的眼皮。{自然讲述}  \n旁白：竟然是她。{自然讲述}  \n旁白：汪思月，赵晏池的初恋。{自然讲述}  \n旁白：刚在一起的时候我就听过这个名字。{自然讲述}  \n旁白：可那时他信誓旦旦地和我保证，他们已经是过去式了。{自然讲述}  \n旁白：他的心里只有我一个人。{自然讲述}  \n旁白：不等我想太多，赵晏池下一句话像一道惊雷劈下来。{自然讲述}  \n赵晏池(男)：好，就听你的。{冷漠}  \n旁白：他对那几个保镖淡然道：{自然讲述}  \n赵晏池(男)：她归你们了，别玩死，死在这儿太晦气。{冷漠}  \n旁白：保镖的脸上露出欣喜而猥琐的笑容。{自然讲述}  \n旁白：我拼命摇头，张开嘴想告诉他们我的真实身份。{自然讲述}  \n旁白：可药物作用让我发不出一个完整的音节。{自然讲述}  \n旁白：拼尽全力，我也只能呼出嗬哧嗬哧的气声。{自然讲述}  \n旁白：他们摩拳擦掌着靠近我。{自然讲述}  \n旁白：拖着死鱼一样的身体，我吃力地在地上匍匐，可这全然是徒劳。{自然讲述}  \n旁白：很快，我便被他们按住，压在身下。{自然讲述}  \n旁白：撕裂一般的疼痛占据了我的身体，生理性的恶心冲撞着我的五脏六腑。{自然讲述}  \n旁白：不多时，小腹处传来一阵坠痛。{自然讲述}  \n旁白：我眼睁睁看着自己身下晕开一片血迹。{自然讲述}  \n旁白：我知道，我的孩子终究是没保住。{自然讲述}  \n旁白：保镖愣了一瞬间后也反应过来。{自然讲述}  \n保镖(男)：这娘们儿还怀孕了？{惊讶}  \n保镖(男)：怀孕？{惊讶}  \n旁白：赵晏池听到这两个字蹙起眉。{自然讲述}  \n旁白：他似乎想到了什么，拿起手机发了条消息。{自然讲述}  \n旁白：我放在袋子里的手机响起轻微的提示音，可惜没人听见。{自然讲述}  \n旁白：他没有再多想：{自然讲述}  \n赵晏池(男)：你们继续吧。{冷漠}  \n旁白：我无神地盯着天花板，泪水糊满了整张脸。{自然讲述}  \n旁白：绝望将我包围，整个人都陷入深不见底的深渊。{自然讲述}"';
        // $text = json_decode($text, true);
        $text = $this->deepseekService->generateScriptWords($cid, 'r1');
        \Log::info('text: '.json_encode($text, 256));
        // $token = getTextTokens($text);
        $result = handleScriptWords($text);
        $role_gender = getProp($result, 'role_gender');
        $role_timbre = [];
        foreach ($role_gender as $role => $gender) {
            $timbre = DB::table('mp_timbres')->where('gender', $gender)->first();
            if (!$timbre) {
                $role_timbre[$role] = ['timbre_type' => 'zh_male_ruyayichen_emo_v2_mars_bigtts', 'timbre_name' => '儒雅男友'];
            }else {
                $timbre_name = str_replace('（多情感）', '', $timbre->timbre_name);
                $role_timbre[$role] = [
                    'timbre_type' => $timbre->timbre_type,
                    'timbre_name' => $timbre_name
                ];
            }
        }

        // 更新角色-音色信息
        $existed_role_info = DB::table('mp_book_version')->where('bid', $bid)->where('id', $version_id)->value('role_info');
        $existed_role_info = json_decode($existed_role_info, true);
        if ($existed_role_info) $existed_roles = array_keys($existed_role_info);
        else $existed_roles = [];
        foreach ($role_timbre as $role => $timbre) {
            if (!in_array($role, $existed_roles)) {
                $existed_role_info[$role] = $timbre;
            }
        }

        // 获取情感信息
        $emotion_list = DB::table('mp_emotion_list')->where('is_enabled', 1)->pluck('emotion_name', 'emotion_code')->toArray();
        $emotion_list = array_flip($emotion_list);

        // 构造生成音频的json
        $words = getProp($result, 'words');
        foreach($words as &$word) {
            $role = getProp($word, 'role');
            $word['gender'] = (int)$word['gender'];
            if (isset($emotion_list[getProp($word, 'emotion')])) {  // 如果有对应情感则赋值,没有则默认为中性(neutral)
                $word['emotion_type'] = $emotion_list[getProp($word, 'emotion')];
            }else {
                $word['emotion'] = '中性';
                $word['emotion_type'] = 'neutral';
            }
            $word['voice_name'] = $role_timbre[$role]['timbre_name'];
            $word['voice_type'] = $role_timbre[$role]['timbre_type'];
            $word['speed_ratio'] = mt_rand(9,11)/10;
            $word['loudness_ratio'] = mt_rand(5,12)/10;
            $word['emotion_scale'] = mt_rand(1,5);
        }
        $generate_json = json_encode($words, 256);
        \Log::info('generate_json: '.$generate_json);

        try {
            DB::beginTransaction();
            $role_info = json_encode($existed_role_info, 256);
            $boolen = DB::table('mp_book_version')->where('bid', $bid)->where('id', $version_id)->update(['role_info' => $role_info, 'updated_at' => date('Y-m-d H:i:s')]);
            if (!$boolen) {
                DB::rollBack();
                dd('更新角色信息失败');
            }

            $count = DB::table('mp_audio_tasks')->where('bid', $bid)->where('version_id', $version_id)->where('cid', $cid)->count('id');
            $chapter_audio = DB::table('mp_chapter_audios')->where('bid', $bid)->where('version_id', $version_id)->where('cid', $cid)->first();
            if (!$count) {
                $task_name = getProp($chapter_audio, 'book_name').' '.getProp($chapter_audio, 'chapter_name').'【'.getProp($chapter_audio, 'version_name').'】';
            }else {
                $task_name = getProp($chapter_audio, 'book_name').' '.getProp($chapter_audio, 'chapter_name').'【'.getProp($chapter_audio, 'version_name').'】('.($count+1).')';
            }
            $boolen1 = DB::table('mp_chapter_audios')->where('bid', $bid)->where('version_id', $version_id)->where('cid', $cid)->update(['generate_status'=>'执行中', 'generate_json' => $generate_json, 'updated_at' => date('Y-m-d H:i:s')]);
            if (!$boolen1) {
                DB::rollBack();
                dd('更新生成数据失败');
            }
            $boolen2 = DB::table('mp_audio_tasks')->insert([
                'audio_id'      => getProp($chapter_audio, 'id'),
                'status'        => '执行中',
                'generate_json' => $generate_json,
                'bid'           => $bid,
                'book_name'     => getProp($chapter_audio, 'book_name'),
                'version_id'    => $version_id,
                'version_name'  => getProp($chapter_audio, 'version_name'),
                'cid'           => $cid,
                'chapter_name'  => getProp($chapter_audio, 'chapter_name'),
                'task_name'     => $task_name,
                'created_at'    => date('Y-m-d H:i:s'),
                'updated_at'    => date('Y-m-d H:i:s')
            ]);
            if (!$boolen2) {
                DB::rollBack();
                dd('创建任务失败');
            }
        } catch (\Exception $e) {
            DB::rollBack();
            dd('失败');
        }
        DB::commit();
        \Log::info('~~~~~~~~~~~~~~~~~~~~~~~~结束~~~~~~~~~~~~~~~~~~~~~~~~');
        dd('成功!');
        // \Log::info('generate_json: '.$generate_json);
    }
}
