<?php

namespace App\Consts;

class ErrorConst
{
    // 基础错误
    const RECORD_NOT_EXIST                  = '1001:记录不存在';
    const DATA_EXCEPTION                    = '1002:数据异常';
    const PARAM_ERROR_CODE                  = '1003:请确认填写的数据无误';
    const TASK_DOING                        = '1004:任务执行中';
    const NOT_ACCESS                        = '1005:没有权限';
    const SYS_EXCEPTION                     = '1006:系统错误';
    const FREQUENT_OPERATION                = '1007:操作频繁，请稍后操作';
    const NOT_LOGIN                         = '1008:请先登录';
    const NOT_OPENED                        = '1009:功能暂未开放';
    const DB_INVALID                        = '1010:信息更新失败,请联系管理员';
    const STOP_TRANSACTION                  = '1011:事务异常，中止事务';
    const ACCOUNT_NOT_MATCH_DOMAIN          = '1012:账号与域名不匹配';
    const REDIS_KEY_NOT_EXIST               = '1013:the redis key is not found';
    const REPORT_FAILED                     = '1014:回传上报错误';
    const CHANNEL_ID_INVALID                = '1015:确认选择有效站点';
    const NO_DATA_FOR_EXPORT                = '1016:无有效数据可导出';
    const FINANCE_SMS_FAILED                = '1017:手机验证码发送失败';
    const FINANCE_SMS_EXIST                 = '1018:手机验证码已发送';
    const FINANCE_SMS_CHECK_FAILED          = '1019:手机验证码错误';
    const FINANCE_SMS_CHECK_EXPIRED         = '1020:手机验证码已过期';
    const FINANCE_SMS_CHECK_LIMIT           = '1021:手机验证码发送频率过快';
    const FINANCE_PHONE_ERROR               = '1022:请联系开发者设置有效手机号';
    const FINANCE_CARD_NUMBER_ERROR         = '1023:银行卡号格式不正确';
    const DATE_START_GREATER_THAN_END       = '1024:开始时间不能大于结束时间';
    const DATE_RANGE_LESS_THAN_7DAY         = '1025:只能选择7日前日期范围';

    // 业务错误
    const CHAPTER_NOT_EXIST                 = '10001:该章节不存在,请重试~';
    const VIP_VALID                         = '10002:付费章节需开通会员才可阅读';
    const BOOK_NOT_EXIST                    = '10003:该书籍不存在或已下架,请重试~';
    const SEND_ORDER_NOT_EXIST              = '10004:该派单链接不存在,请确认后重试~';
    const CHANNEL_NOT_EXIST                 = '10005:该站点不存在,请确认后重试~';
    const USER_COIN_NOT_ENOUGH              = '10006:您的书币不足,请先充值~';
    const DECREASE_COIN_FAILED              = '10007:书币扣减失败,请从目录页重新进入当前章节~';
    const SEND_ORDER_NAME_INVALID           = '10008:派单名称重复,请修改后重试~';
    const DATE_RANGE_OVER_MONTH             = '10009:时间范围筛选超过一个月';

	// 用户相关
    const USER_INI_FAIL                     = '20001:用户创建失败';
    const USER_DATA_IS_VALID                = '20002:用户数据异常';
    const USER_IS_NOT_EXIST                 = '20003:用户不存在';
    const USER_DATA_IS_EMPTY                = '20004:用户数据不完整';
    const USER_OPENID_NOT_MATCH             = '20005:用户openid不匹配';
    const USER_APPID_NOT_MATCH              = '20006:用户appid不匹配';
    const USER_AUTH_FAIL                    = '20007:授权失败，请联系客服';
    const USER_IS_EXIST                     = '20007:用户已存在';
    const USER_NO_ACCESS_CHANNEL            = '20008:当前登录用户无此站点权限';

    // Finance
    const FINANCE_ACCOUNT_EXISTED           = '60001:账户已在使用中';
    const WITHDRAW_CASH_AMOUNT              = '60002:提现金额必须 >= 100';
    const WITHDRAW_CASH_AMOUNT_MORE         = '60002:提现金额不能大于20万';
    const WITHDRAW_CASH_AMOUNT_INSUFFICIEN  = '60003:可提现金额不足';
    const WITHDRAW_CASH_AMOUNT_FROZEN       = '60004:账号已冻结';
    const WITHDRAW_CASH_AMOUNT_NO_CHANGE    = '60005:不能修改状态';
    const WITHDRAW_CASH_AMOUNT_ACCOUNT      = '60006:银行卡账号未设置';
    const PAYMENT_CHANNEL_AMOUNT_WITHOUT    = '60007:渠道可打款金额不足，请走人工打款';
    const LIQUIDATED_STAT_AMOUNT_WITHOUT    = '60008:渠道可清算金额不足';
    const COMMISSION_RATE_WITHOUT           = '60009:结算比例在 0.1 到 0.99 之间';
    const WITHDRAW_CASH_TODAY_USE           = '60010:您今天已经提现过了！';
    const PAYMENT_AUTO_NOT_OPEN             = '60007:自动打款暂未开通，请人工打款！';
    const PAYMENT_WITHDRAW_MONEY_TOO        = '60012:已成功打款！';
    const PAYMENT_WITHDRAW_MONEY            = '60013:打款金额错误，提现金额 - 手续费 = 打款金额';
    const PRIVATE_ACCOUNT_NOT_SUFFICIENT    = '60014:当前是对私提现，对私账户余额不足！';
    const PRIVATE_ACCOUNT_NO_ACCESS         = '60015:当前账号无权限';
    const CAPTCHA_VERIFY_ERROR              = '10021:验证码错误';
    const NOT_ALLOWED_PRIVATE_ACCOUNT       = '10018:该渠道只能对公打款';
    const WITHDRAW_UPDATING                 = '10019:提现升级中，请稍后再试！';
    const WITHDRAW_PRIVATE_NOT_ENOUGH       = '10020:当前对私账户余额不足!';
    const WITHDRAW_NOT_ENOUGH               = '10021:账户余额不足!';
    const CASH_ACCOUNT_NOT_SET              = '10006:提现账户未设置';
    const CASH_ACCOUNT_EXIST                = '10007:提现账户已存在';
    const INSUFFICIENT_BALANCE              = '10008:余额不足';
    const LESS_THAN_LOWEST_WITHDRAW_MONEY   = '10009:提现不能低于100';
    const WITHDRAW_CASHES_FAILED            = '10012:提现失败';
    const WITHDRAW_CASH_AMOUNT_NOT_MATCH    = '10013:银行卡账号对公对私与提现选项不匹配';
}
