<?php

/**
 * This file is part of the apiadmin/tiktok.
 */

namespace App\Libs\TikTok\OpenPlatform\Auth;

use App\Libs\TikTok\OpenPlatform\Kernel\AccessToken as BaseAccessToken;

/**
 * AccessToken 【用于开放平台获取授权AccessToken】
 *
 * @author zhaoxiang <zhaoxiang051405@gmail.com>
 */
class AccessToken extends BaseAccessToken {

    /**
     * @var string
     */
    protected $endpointToGetToken = 'oauth/client_token/';

    /**
     * 配置AccessToken的
     *
     * @return array
     */
    protected function getCredentials(): array
    {
        return [
            'client_key'    => $this->app['config']['app_id'],
            'client_secret' => $this->app['config']['secret'],
            'grant_type'    => 'client_credential',
        ];
    }
}
