<?php

use App\Http\Controllers\Account\AccountController;
use App\Http\Controllers\DeepSeek\DeepSeekController;
use App\Http\Controllers\Book\BookController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::group(['middleware' => ['bindToken', 'bindExportToken', 'checkLogin']], function () {

    Route::group(['prefix' => 'book'], function () {
        // 书籍管理
        Route::get('list', [BookController::class, 'bookList']);
        Route::get('all', [BookController::class, 'allBooks']);
        Route::get('chapterList', [BookController::class, 'chapterList']);
        Route::get('chapterContent', [BookController::class, 'chapterContent']);

        // 版本管理
        Route::get('addVersion', [BookController::class, 'addBookVersion']);
        Route::get('bookVersion', [BookController::class, 'bookVersion']);
        Route::get('versionList', [BookController::class, 'versionList']);
        Route::get('taskList', [BookController::class, 'taskList']);
        Route::get('taskDetail', [BookController::class, 'taskDetail']);
    });

    Route::group(['prefix' => 'deepseek'], function () {
        Route::post('chatWithReasoner', [DeepSeekController::class, 'chatWithReasoner']);
        Route::get('timbreList', [DeepSeekController::class, 'timbreList']);
        Route::post('addGenerateTask', [DeepSeekController::class, 'addGenerateTask']);
        Route::get('setStsToken', [DeepSeekController::class, 'setStsToken']);
    });
    
});


Route::get('login', [AccountController::class, 'login']); // 登录
Route::get('logout', [AccountController::class, 'logout']); // 退出